<?php

namespace Gregwar\ImageBundle\Extensions;

use Symfony\Component\DependencyInjection\ContainerInterface;

/**
 * ImageTwig extension
 *
 * @author Gregwar <g.passault@gmail.com>
 * @author bzikarsky <benjamin.zikarsky@perbility.de>
 */
class ImageTwig extends \Twig_Extension
{
    private $container;
    private $environment;

    public function __construct(ContainerInterface $container)
    {
        $this->container = $container;
    }

    public function initRuntime(\Twig_Environment $environment)
    {
        $this->environment = $environment;
    }

    public function getFunctions()
    {
        return array(
            new \Twig_SimpleFunction('image', array($this, 'image'), array('is_safe' => array('html'))),
            new \Twig_SimpleFunction('new_image', array($this, 'newImage'), array('is_safe' => array('html'))),
            new \Twig_SimpleFunction('web_image', array($this, 'webImage'), array('is_safe' => array('html'))),
        );
    }

    public function webImage($path)
    {
        $directory = $this->container->getParameter('gregwar_image.web_dir') .'/';
        return $this->container->get('image.handling')->open($directory . $path);
    }

    public function image($path)
    {
        return $this->container->get('image.handling')->open($path);
    }

    public function newImage($width, $height)
    {
        return $this->container->get('image.handling')->create($width, $height);
    }

    public function getName()
    {
        return 'image';
    }
}

